// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from nao_command_msgs:msg/HeadLeds.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "nao_command_msgs/msg/head_leds.hpp"


#ifndef NAO_COMMAND_MSGS__MSG__DETAIL__HEAD_LEDS__STRUCT_HPP_
#define NAO_COMMAND_MSGS__MSG__DETAIL__HEAD_LEDS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__nao_command_msgs__msg__HeadLeds __attribute__((deprecated))
#else
# define DEPRECATED__nao_command_msgs__msg__HeadLeds __declspec(deprecated)
#endif

namespace nao_command_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct HeadLeds_
{
  using Type = HeadLeds_<ContainerAllocator>;

  explicit HeadLeds_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<float, 12>::iterator, float>(this->intensities.begin(), this->intensities.end(), 0.0f);
    }
  }

  explicit HeadLeds_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : intensities(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<float, 12>::iterator, float>(this->intensities.begin(), this->intensities.end(), 0.0f);
    }
  }

  // field types and members
  using _intensities_type =
    std::array<float, 12>;
  _intensities_type intensities;

  // setters for named parameter idiom
  Type & set__intensities(
    const std::array<float, 12> & _arg)
  {
    this->intensities = _arg;
    return *this;
  }

  // constant declarations
  static constexpr int32_t B0 =
    0;
  static constexpr int32_t B1 =
    1;
  static constexpr int32_t B2 =
    2;
  static constexpr int32_t B3 =
    3;
  static constexpr int32_t B4 =
    4;
  static constexpr int32_t B5 =
    5;
  static constexpr int32_t B6 =
    6;
  static constexpr int32_t B7 =
    7;
  static constexpr int32_t B8 =
    8;
  static constexpr int32_t B9 =
    9;
  static constexpr int32_t B10 =
    10;
  static constexpr int32_t B11 =
    11;
  static constexpr int32_t NUM_LEDS =
    12;

  // pointer types
  using RawPtr =
    nao_command_msgs::msg::HeadLeds_<ContainerAllocator> *;
  using ConstRawPtr =
    const nao_command_msgs::msg::HeadLeds_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<nao_command_msgs::msg::HeadLeds_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<nao_command_msgs::msg::HeadLeds_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      nao_command_msgs::msg::HeadLeds_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<nao_command_msgs::msg::HeadLeds_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      nao_command_msgs::msg::HeadLeds_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<nao_command_msgs::msg::HeadLeds_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<nao_command_msgs::msg::HeadLeds_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<nao_command_msgs::msg::HeadLeds_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__nao_command_msgs__msg__HeadLeds
    std::shared_ptr<nao_command_msgs::msg::HeadLeds_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__nao_command_msgs__msg__HeadLeds
    std::shared_ptr<nao_command_msgs::msg::HeadLeds_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const HeadLeds_ & other) const
  {
    if (this->intensities != other.intensities) {
      return false;
    }
    return true;
  }
  bool operator!=(const HeadLeds_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct HeadLeds_

// alias to use template instance with default allocator
using HeadLeds =
  nao_command_msgs::msg::HeadLeds_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t HeadLeds_<ContainerAllocator>::B0;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t HeadLeds_<ContainerAllocator>::B1;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t HeadLeds_<ContainerAllocator>::B2;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t HeadLeds_<ContainerAllocator>::B3;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t HeadLeds_<ContainerAllocator>::B4;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t HeadLeds_<ContainerAllocator>::B5;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t HeadLeds_<ContainerAllocator>::B6;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t HeadLeds_<ContainerAllocator>::B7;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t HeadLeds_<ContainerAllocator>::B8;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t HeadLeds_<ContainerAllocator>::B9;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t HeadLeds_<ContainerAllocator>::B10;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t HeadLeds_<ContainerAllocator>::B11;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t HeadLeds_<ContainerAllocator>::NUM_LEDS;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace nao_command_msgs

#endif  // NAO_COMMAND_MSGS__MSG__DETAIL__HEAD_LEDS__STRUCT_HPP_
